<?php

function PDFMemberDirectory($FileName, $GroupArray)
{

		$PDF = PDF_Create("", $FileName, "", "");
		$FileName = $FileName.".pdf";

		// Initialize PageVarArray - this array holds font info, page metrics, etc.

			// structural information
				$PageVarArray['A_Width'] = 144; // width of address block (2")
				$PageVarArray['X_Gutter'] = 18;   // width of gutter (0.25")
				$PageVarArray['Y_Gutter'] = 4;    // height of space between address blocks (0.05")
				$PageVarArray['X_Outside'] = 54;  // origin of X (outside)
				$PageVarArray['X_Inside'] = 36;   // origin of X (inside)
				$PageVarArray['Y_Top'] = 565;     // origin of Y (top) (0.65" from top, 7.85" from bottom)
				$PageVarArray['Y_End'] = 36;      // Limit of Y (bottom) (7.75" from top, 0.75" from bottom)
				$PageVarArray['P_Width'] = 396;   // width of page (1/2 letter = 5.5")
				$PageVarArray['P_Height'] = 612;  // height of page (1/2 letter = 8.5")
				$PageVarArray['Use_Width'] = 306;  // width of usable area (4.25")

			// Standard Page Element Information
				$PageVarArray['TopLineAlign'] = "right"; // default value for first page. Can be "right" (odd pages) or "left" (even pages)
				$PageVarArray['L_Margin'] = $PageVarArray['X_Inside']; // default value for first page. Is either X_Inside (odd pages) or X_Outside (even pages)
				$PageVarArray['R_Margin'] = $PageVarArray['X_Outside']; // default value for first page. Is either X_Inside (odd pages) or X_Outside (even pages)
				$PageVarArray['PageFirstName'] = ''; // for the topline
				$PageVarArray['PageLastName'] = ''; // for the topline

			// Location Information (which page/column/name and on what page/column/name)
				$PageVarArray['PageNum'] = 0; // initial page number
				$PageVarArray['CurrentY'] = $PageVarArray['Y_Top']; // initial Y value
				$PageVarArray['Col1_Y'] = $PageVarArray['Y_Top']; // default is Y_Top but is set to the bottom of each column.
				$PageVarArray['Col2_Y'] = $PageVarArray['Y_Top']; // default is Y_Top but is set to the bottom of each column.
				$PageVarArray['Col_Y'] = $PageVarArray['Y_Top']; // a 'neutral' counter for Y - refers to Col1_Y and Col2_Y.
				$PageVarArray['Col_L_Margin'] = $PageVarArray['X_Inside']; // default value for first column. Is either X_Inside or X_Inside + A_Width + X_Gutter
				$PageVarArray['LetterEndFlag'] = 0; // When all address blocks for a letter have been placed, set to one. Reset to zero at beginning of of Letter loop.
				$PageVarArray['CurrentName'] = '';  // set to whatever the current name is - used in laying out columns. 
				$PageVarArray['Col1_FirstName'] = ''; // name value for first address block for col 1 - these values are set during the column set up, used during the column "print".
				$PageVarArray['Col1_LastName'] = '';  // name value for last address block for col 1
				$PageVarArray['Col2_FirstName'] = ''; // name value for first address block for col 2
				$PageVarArray['Col2_LastName'] = ''; // name value for last address block for col 2

			// Font Information
				$PageVarArray['Fonts']['F_Hel'] = pdf_findfont($PDF, "Helvetica", "host", 0);
				$PageVarArray['Fonts']['F_Hel_B'] = pdf_findfont($PDF, "Helvetica-Bold", "host", 0);
				$PageVarArray['Fonts']['F_Hel_O'] = pdf_findfont($PDF, "Helvetica-Oblique", "host", 0);
				$PageVarArray['Fonts']['F_Hel_BO'] = pdf_findfont($PDF, "Helvetica-BoldOblique", "host", 0);
				$PageVarArray['Fonts']['F_Tim'] = pdf_findfont($PDF, "Times-Roman", "host", 0);
				$PageVarArray['Fonts']['F_Tim_B'] = pdf_findfont($PDF, "Times-Bold", "host", 0);

			// Font Size Information
				$PageVarArray['FontSize']['TopLine'] = 10; // top name line - i.e. "Abbate to Barry"
				$PageVarArray['FontSize']['Letter'] = 36; // Beginning letter for each section - i.e. "- A -"
				$PageVarArray['FontSize']['PageNum'] = 10; // page number - i.e. "- 1 -"
				$PageVarArray['FontSize']['NameLine'] = 8; // name line for each address block - i.e. "Abbate, Janet"
				$PageVarArray['FontSize']['TextLine'] = 8; // address lines - i.e. "10 Downing Street" - includes phone, email, etc.
				$PageVarArray['FontSize']['NameLineHeight'] = 9; // height of name text line in address block
				$PageVarArray['FontSize']['TextLineHeight'] = 9; // height of one text line in address block


		// $LetterArray holds the processed "raw" data from $GroupArray - names are formed, metrics calculated, etc.
		// Information from ProcessDirectoryData & CalcAddressBlockRows is ready to be placed on page.
		//		$LetterArray structure:
		//			$LetterArray[$FirstLetter]['Name']['NameLine']
		//											  ['FamOrgID']
		//											  ['CityStateZipLine']
		//											  ['EmailLine']
		//											  ['NameLineRowCount']
		//											  ['EmailLineRowCount']
		//											  ['PhoneLineRowCount']
		//											  ['BlockHeight']
		$LetterArray = ProcessDirectoryData($GroupArray);
		$LetterArray = CalcAddressBlockRows($LetterArray, $PDF, $PageVarArray);

		// Set up initial page - "priming the pump"
		list($PDF, $PageVarArray) = BeginNewPage($PDF, $PageVarArray);

		// begin big loop to process addresses by letter
	   foreach ($LetterArray as $Letter => $CurrentLetterArray)
	   {
			// Reset Letter End Flag to zero (1 means at end of letter).
				$PageVarArray['LetterEndFlag'] = 0;

			// Need to check for enough space for at least big letter + 1 line of addresses (first 2 address blocks)

				// Get the key for the first address block of the current letter and use it to get the first address block height.
				$Block1_Height = $CurrentLetterArray[key($CurrentLetterArray)]['BlockHeight'];
				// if there is more than one block, do the same for the second block.
				if(next($CurrentLetterArray))
				{$Block2_Height = $CurrentLetterArray[key($CurrentLetterArray)]['BlockHeight'];}
				// If not more than one block, set 2nd key to equal zero.
				else
				{$Block2_Height = 0;}
				 // Reset the pointer to the beginning of the array.
				reset($CurrentLetterArray);

				// Assign the bigger value to a new value for comparison.
				if($Block1_Height > $Block2_Height) {$BlockHeight = $Block1_Height;}
				else {$BlockHeight = $Block2_Height;}
				// Calculate the minimum space needed: letter height + block height + padding for the Y-gutter.
				$MinSpace = $PageVarArray['FontSize']['Letter'] + $BlockHeight + (2*$PageVarArray['Y_Gutter']);

				// The actual comparison against the current-Y. If not enough space, close out page and start a new page.
				if ( ($PageVarArray['CurrentY'] - $PageVarArray['Y_End']) < $MinSpace)
				{
						// close out page
						$PDF = CloseOutPage($PDF, $PageVarArray);
						// start new page
						list($PDF, $PageVarArray) = BeginNewPage($PDF, $PageVarArray);
				}

			// Do the NewLetter function - places the new letter on the page and adjusts the page vars accordingly.
			   list($PDF, $PageVarArray) = NewLetter($CurrentLetterArray, $PDF, $PageVarArray, $Letter);

				// This loop is what places all the address blocks for the current letter on the page, starts new pages/columns as needed. - the *really* important loop...
			   while ($PageVarArray['LetterEndFlag'] != 1) // zero means there are address blocks to be placed, 1 means all the blocks for the current letter have been placed.
				{
						// Do the TwoColumn function which "fills" each columnn with blocks.
					   list($PDF, $PageVarArray) = TwoColumn($CurrentLetterArray, $PDF, $PageVarArray);

						// if CurrentName is NOT equal to the last element AND the LetterEndFlag is not set, there are more address blocks to place.
							if (($PageVarArray['CurrentName'] != LastArrayElementKey($CurrentLetterArray)) && ($PageVarArray['LetterEndFlag'] != 1))
							{
								// Because TwoColumn will either fill the page or place all available blocks, we know that we need to end/begin a page.
									// close out page
									$PDF = CloseOutPage($PDF, $PageVarArray);
									// start new page
									list($PDF, $PageVarArray) = BeginNewPage($PDF, $PageVarArray);

								// Need to find the current location if the CurrentLetterArray. **** Might want to break this out into a seperate function.
									// Reset the pointer to the beginning of the array.
									reset($CurrentLetterArray);
									// The only time CurrentName should be empty is at the beginning of a new letter.
									if ($PageVarArray['CurrentName'] != '')
									{
											// Walk through the array and set the pointer to the CurrentName.
											while (key($CurrentLetterArray) != $PageVarArray['CurrentName'])
											{next($CurrentLetterArray);}
											// Set the CurrentName to the NEXT address block since the last one was used already.
											next($CurrentLetterArray);
									}
									// Now set CurrentName to the current key for CurrentLetterArray. If this is a new letter, it will be set to the first key for CurrentLetterArray.
									$PageVarArray['CurrentName']  = key($CurrentLetterArray);
							}
				} // END Do WHILE
		} // END BIG LETTER LOOP

		// At the end of placing all of the Letters and address blocks, need to close out the page
		$PDF = CloseOutPage($PDF, $PageVarArray);
		// Also need to close out the PDF and open it in a new window
		$output = PDF_CloseOut($PDF, $FileName, "attachment");
		return $output;
} // END FUNCTION

function BeginNewPage($PDF, $PageVarArray)
{
		// Increment page number by one.
		$PageVarArray['PageNum'] += 1;

		// Start a new page in the growing PDF.
		pdf_begin_page($PDF, $PageVarArray['P_Width'], $PageVarArray['P_Height']);
		pdf_setcolor($PDF, "stroke", "rgb", 0, 0, 0, 0);

		// Set margins and such for even/odd page.
			if($PageVarArray['PageNum'] & 1) // this is a bitwise operator. True = odd, False = even.
			{
					// Odd Pages
					$PageVarArray['TopLineAlign'] = "right";
					$PageVarArray['L_Margin'] = $PageVarArray['X_Inside']; // 36
					$PageVarArray['R_Margin'] = $PageVarArray['X_Inside'] + $PageVarArray['Use_Width'];
			}
			else
			{
					// Even Pages
					$PageVarArray['TopLineAlign'] = "left";
					$PageVarArray['L_Margin'] = $PageVarArray['X_Outside']; // 54
					$PageVarArray['R_Margin'] = $PageVarArray['X_Outside'] + $PageVarArray['Use_Width'];
			}

		// reset the current-Y to the beginning point
			$PageVarArray['CurrentY'] = $PageVarArray['Y_Top'];
		// Set/reset PageFirstName & PageLastName to null
		   $PageVarArray['PageFirstName'] = '';
		   $PageVarArray['PageLastName'] = '';
		// Set/reset ColNames to null
			$PageVarArray['Col1_FirstName'] = '';
			$PageVarArray['Col1_LastName'] = '';
			$PageVarArray['Col2_FirstName'] = '';
			$PageVarArray['Col2_LastName'] = '';

		// Return PDF & modified PageVarArray
	   $ReturnArray = array($PDF, $PageVarArray);
	   return $ReturnArray;
}

function CloseOutPage($PDF, $PageVarArray)
{
	// Put the standard elements on the page (page number, header, footer, etc.)

		// "Print" out the PageFirstName & PageLastName (Adams to Bates) - top text line
			// set font
			$FontSize = $PageVarArray['FontSize']['TopLine'];
			// calculate where (vertically) to put the top text line
			$Line_Y = $PageVarArray['Y_Top'] + $FontSize;
			// build the text
			$LineText = $PageVarArray['Col1_FirstName']."  to  ".$PageVarArray['Col2_LastName'];
			// set font and place text
			pdf_setfont($PDF, $PageVarArray['Fonts']['F_Hel_B'], $FontSize);
			pdf_show_boxed($PDF, $LineText, $PageVarArray['L_Margin'], $Line_Y, $PageVarArray['Use_Width'], $FontSize, $PageVarArray['TopLineAlign'], "");
			// Reset First & Last Names to null
			$PageVarArray['Col1_FirstName'] = '';
			$PageVarArray['Col2_LastName'] = '';

		// "Print" out top line
			// calculate where (vertically) to put the top line
			$Line_Y = $PageVarArray['Y_Top'] + $FontSize - 2; // 2 is to give a little space between the top line text and the top line.
			// draw the line
			$PDF = DrawLine($PDF, $PageVarArray['L_Margin'], $Line_Y, $PageVarArray['R_Margin'], $Line_Y);

		// "Print" out page number
			// set font
			$FontSize = $PageVarArray['FontSize']['PageNum'];
			// calculate where (vertically) to put the page number
			$Line_Y = $PageVarArray['Y_End'] - $FontSize;
			// build the page number text
			$LineText = "-  ".$PageVarArray['PageNum']."  -";
			// set font and place text
			pdf_setfont($PDF, $PageVarArray['Fonts']['F_Hel_B'], $FontSize);
			pdf_show_boxed($PDF, $LineText, $PageVarArray['L_Margin'], $Line_Y, $PageVarArray['Use_Width'], $FontSize, "center", "");

		// now end the page and return the PDF.
		pdf_end_page($PDF);
	   return $PDF;
}

function NewLetter($CurrentLetterArray, $PDF, $PageVarArray, $Letter)
{
	// Creates the letter heading on the current page at the "right" location

		// Add dashes for format to the letter
		$Letter = "- ".$Letter." -";
		// Subtract the height of the letter from current Y
		$PageVarArray['CurrentY'] -= $PageVarArray['FontSize']['Letter'];
		// Put the letter on the page
		pdf_setfont($PDF, $PageVarArray['Fonts']['F_Tim_B'], $PageVarArray['FontSize']['Letter']);		
		pdf_show_boxed($PDF, $Letter, $PageVarArray['L_Margin'], $PageVarArray['CurrentY'], $PageVarArray['Use_Width'], $PageVarArray['FontSize']['Letter'], "center", ""); // left, top, width, height
		// Take the "gutter" distance from the current Y (space under the letter)
		$PageVarArray['CurrentY'] -= $PageVarArray['Y_Gutter'];

		// set $PageVarArray['CurrentName'] to the first name of the current letter
		// since this function (NewLetter) is only run at the start of a new letter, no need to use current().
		$PageVarArray['CurrentName'] = $CurrentLetterArray['Name'];
		
		// Return PDF & modified PageVarArray
		$ReturnArray = array($PDF, $PageVarArray);
		return $ReturnArray;
}

function TwoColumn($CurrentLetterArray, $PDF, $PageVarArray)
{
	// Output values are: PageVarArray, current position in current letter array, PDF

	// Do column loop functions for each column
		   list($PageVarArray, $Column1) = ColumnLoop($CurrentLetterArray, $PageVarArray);
			// at end of letter?
			if ($PageVarArray['LetterEndFlag'] != 1)
			{list($PageVarArray, $Column2) = ColumnLoop($CurrentLetterArray, $PageVarArray);} // YES there are addresses remaining so do 2nd column loop
			else
			{
				$Column2 = '';  // set column 2 to ''- might not need this here.
			}

	// Do column balance function/loop
	   list($PageVarArray, $Column1, $Column2) = ColumnBalance($PageVarArray, $Column1, $Column2);

	// Set First and last addresses from columns into PageVarArray
	   $PageVarArray = SetFirstLastColumnAddress($PageVarArray, $Column1, 1);
	   if($Column2)
	   {$PageVarArray = SetFirstLastColumnAddress($PageVarArray, $Column2, 2);}

	   // "Print" columns to PDF page
		// Set PageFirstName
		   if ($PageVarArray['PageFirstName'] == '')
		   {
				// set PageFirstName to first address in first column
				reset($Column1); // might not need this.
				$PageVarArray['PageFirstName'] = key(current($Column1));
		   }

		// Set PageLastName & CurrentName
		$PageVarArray['PageLastName'] = LastArrayElementKey($Column2);
		$PageVarArray['CurrentName'] = $PageVarArray['PageLastName'];
		
		// check if at end of letter
		if ($PageVarArray['PageLastName'] == LastArrayElementKey($CurrentLetterArray))
		{$PageVarArray['LetterEndFlag'] = 1;} // end of letter = 1.
		
		// "Print" the columns
		list($PDF, $PageVarArray) = PDFPrintColumn($PDF, $PageVarArray, $Column1, 1);
		if ($Column2)
		{list($PDF, $PageVarArray) = PDFPrintColumn($PDF, $PageVarArray, $Column2, 2);}

		// Set new available column height and other page vars needed.
		if ( $PageVarArray['Col1_Y'] > $PageVarArray['Col2_Y'] )
		{$PageVarArray['CurrentY'] = $PageVarArray['Col2_Y'];}
		else
		{$PageVarArray['CurrentY'] = $PageVarArray['Col1_Y'];}

		// Return PDF & modified PageVarArray
	   $ReturnArray = array($PDF, $PageVarArray);
	   return $ReturnArray;
}

function PDFPrintColumn($PDF, $PageVarArray, $ColumnArray, $ColumnNumber)
{
	// set the left margin
	if ($ColumnNumber == 1)
	{$PageVarArray['Col_L_Margin'] = $PageVarArray['L_Margin'];}
	else
	{$PageVarArray['Col_L_Margin'] = $PageVarArray['L_Margin'] + $PageVarArray['A_Width'] + $PageVarArray['X_Gutter'];}
	
	// Set Y height
	$PageVarArray['Col_Y'] = $PageVarArray['CurrentY'];

	// do a loop to "print" each address
	foreach ($ColumnArray as $Address)
	{
		// do a "print" function
		list($PDF, $PageVarArray) = PDFPrintAddress($PDF, $PageVarArray, $Address);
	}
			
	// Adjust the current column Y down.
	if ($ColumnNumber == 1)
	{$PageVarArray['Col1_Y'] = $PageVarArray['Col_Y'];}
	else
	{$PageVarArray['Col2_Y'] = $PageVarArray['Col_Y'];}

	// Return PDF & modified AddressVarArray
	   $ReturnArray = array($PDF, $PageVarArray);
	   return $ReturnArray;
}

function PDFPrintAddress($PDF, $PageVarArray, $Address)
{

	// Name Line
	pdf_setfont($PDF, $PageVarArray['Fonts']['F_Hel_B'], $PageVarArray['FontSize']['NameLine']);
	$LineHeight = $PageVarArray['FontSize']['NameLineHeight'] * $Address['NameLineRowCount'];
	$PageVarArray['Col_Y'] -= $LineHeight;
	pdf_show_boxed($PDF, $Address['NameLine'], $PageVarArray['Col_L_Margin'], $PageVarArray['Col_Y'], $PageVarArray['A_Width'], $LineHeight, "left", "");
	
	// CityStateZipLine Line
	pdf_setfont($PDF, $PageVarArray['Fonts']['F_Hel'], $PageVarArray['FontSize']['TextLine']);
	$LineHeight = $PageVarArray['FontSize']['TextLineHeight'];
	$PageVarArray['Col_Y'] -= $LineHeight;
	pdf_show_boxed($PDF, $Address['CityStateZipLine'], $PageVarArray['Col_L_Margin'], $PageVarArray['Col_Y'], $PageVarArray['A_Width'], $LineHeight, "left", "");
	
	// Email Line
	$LineHeight = $PageVarArray['FontSize']['TextLineHeight'] * $Address['EmailLineRowCount'];
	$PageVarArray['Col_Y'] -= $LineHeight;
	pdf_show_boxed($PDF, $Address['EmailLine'], $PageVarArray['Col_L_Margin'], $PageVarArray['Col_Y'], $PageVarArray['A_Width'], $LineHeight, "left", "");

	// Phone Line
	$LineHeight = $PageVarArray['FontSize']['TextLineHeight'] * $Address['PhoneLineRowCount'];
	$PageVarArray['Col_Y'] -= $LineHeight;
	pdf_show_boxed($PDF, $Address['PhoneLine'], $PageVarArray['Col_L_Margin'], $PageVarArray['Col_Y'], $PageVarArray['A_Width'], $LineHeight, "left", "");

	$PageVarArray['Col_Y'] -= $PageVarArray['Y_Gutter'];

	// Return PDF & PageVarArray
	$ReturnArray = array($PDF, $PageVarArray);
	return $ReturnArray;
}

function ColumnLoop($CurrentLetterArray, $PageVarArray)
{
		// reset $AddressArray
		$AddressArray = '';
		// set column metric vars
		$Y_Remain = $PageVarArray['CurrentY'] - $PageVarArray['Y_End'];

		// "find" the current $CurrentLetterArray['Name']
		reset($CurrentLetterArray); // reset the array key to the first element.
		if ($PageVarArray['CurrentName'] == '') // this condition should only occur at the beginning of a new letter.
		{$PageVarArray['CurrentName'] = key($CurrentLetterArray);}
		else
		{
			while (key($CurrentLetterArray) != $PageVarArray['CurrentName'])
			{next($CurrentLetterArray);}
			$PageVarArray['CurrentName']  = key($CurrentLetterArray);
		}

		// Determine the last element Key (name) before the While loop - no need to calculate it every loop iteration
		$LastArrayElementName = LastArrayElementKey($CurrentLetterArray);
	
		// begin loop to populate column
		while($Y_Remain > 0)
		{
			// Is the current block height >= available height? (don't forget space between)
			if ( ($CurrentLetterArray[$PageVarArray['CurrentName']]['BlockHeight'] + $PageVarArray['Y_Gutter']) > ($Y_Remain) )
			{
				$Y_Remain = 0;
				break;
			} // break;} // YES - end the while loop

			// add current array address to $AddressArray - this is the list of address blocks for each column
			$AddressArray[$PageVarArray['CurrentName']] = $CurrentLetterArray[$PageVarArray['CurrentName']];
			// subtract current array address height (plus space) from working area
			$Y_Remain -= ($CurrentLetterArray[$PageVarArray['CurrentName']]['BlockHeight'] + $PageVarArray['Y_Gutter']);
		
			// at end of letter?
			if (key($CurrentLetterArray) == $LastArrayElementName)
			{  // YES - end loop
				$Y_Remain = 0; 
				$PageVarArray['LetterEndFlag'] = 1;
				break;
			}
			else
			{  // NO -  need to increment the pointer one more to get to the next one for the next iteration of the while loop.
				next($CurrentLetterArray);
				$PageVarArray['CurrentName']  = key($CurrentLetterArray);
			}
	}

	// Return PageVarArray & AddressArray
	   $ReturnArray = array($PageVarArray, $AddressArray);
	   return $ReturnArray;
}

function ColumnBalance($PageVarArray, $Column1, $Column2)
{
	// working space available
	$Y_Remain = $PageVarArray['CurrentY']- $PageVarArray['Y_End'];

	// need to calculate height of each column - use a function.
	$Column1_Height = CalculateColumnHeight($Column1);
	$Column2_Height = CalculateColumnHeight($Column2);

	// Set Height of last block of column 1
	$Column1_LastBlockKey = LastArrayElementKey($Column1);
	$Column1_LastBlockHeight = $Column1[$Column1_LastBlockKey]['BlockHeight'];

	// The balance loop.
	// There are a bunch of ways to do the balance (I tried several) but for aesthetics of code and the output as
	//  well as simplicity, I like this one best.
	while( ($Column2_Height + $Column1_LastBlockHeight) < ($Column1_Height))
	{
			// move last address from column 1 to top of column 2.
			$Column2[$Column1_LastBlockKey] = array_pop($Column1);
			// recalculate last block metrics
			$Column1_LastBlockKey = LastArrayElementKey($Column1);
			$Column1_LastBlockHeight = $Column1[$Column1_LastBlockKey]['BlockHeight'];
			// recalculate column heights
			$Column1_Height = CalculateColumnHeight($Column1);
			$Column2_Height = CalculateColumnHeight($Column2);
	}
	
	// need to resort the columns
	uksort($Column1, "strnatcasecmp");
	if($Column2)
	{uksort($Column2, "strnatcasecmp");}

	// return arrays and stuff
	$ReturnArray = array($PageVarArray, $Column1, $Column2);
	return $ReturnArray;
}

function CalculateColumnHeight($AddressBlockArray)
{
	$ColumnHeight = 0;

	if($AddressBlockArray)
	{
		foreach($AddressBlockArray as $key => $value)
		{
			$ColumnHeight += $AddressBlockArray[$key]['BlockHeight'];
		}
	}
	return $ColumnHeight;
}

function LastArrayElementKey($CurrentArray)
{
	if (!is_array($CurrentArray)) return $CurrentArray; // if it isn't an array, return the value
	if (!count($CurrentArray)) return null; // if it's an empty array, return null
	end($CurrentArray); // go to the last element in the array
	return key($CurrentArray); // return the key of this last element.
}
	
function CalcAddressBlockMetrics($GroupArray) 	// might want to rename this function?
{
	   // Count Adr Blocks per letter
	   foreach($GroupArray as $row)
	   {
	      $FirstLetter = strtoupper(substr($row['NameLine'], 0, 1));
	      $LtrCt[$FirstLetter]['Count'] += 1;

	   }
	   return $LtrCt;
}

function ProcessDirectoryData($GroupArray)
{
		foreach($GroupArray as $row)
		{
				// need to count # of members
				$row['MemberCount'] = count($row['Members']);

				if (($row['MemberCount'] > 0) && ($row['MemberTypeID'] != 6)) // 6 == organization
				{
						// need to "fix" family name if it is in the form of "X & Y" -- will truncate it to just "X"
						if(strrpos($row['Name'], "&"))
						{$row['Name'] = substr($row['Name'], 0, strrpos($row['Name'], "&")-1);}
						// Get first letter from name
						$FirstLetter = strtoupper(substr($row['Name'], 0, 1));
						// Name Line
						$NameLine = DirNameLine($row);
						$GroupKey = $NameLine." ".$row['FamOrgID']; // this is needed to be SURE each group is unique - it is possible (but unlikely) to have two "Smith, John" members.
						$LetterArray[$FirstLetter][$GroupKey]['NameLine'] = $NameLine;
						// FamOrgID
						$LetterArray[$FirstLetter][$GroupKey]['FamOrgID'] = $row['FamOrgID'];						
						// Last Name
						$LetterArray[$FirstLetter][$GroupKey]['LastName'] = $row['Name'];
						// City, State, Zip Line
						$LetterArray[$FirstLetter][$GroupKey]['CityStateZipLine'] = DirCityStateZipLine($row);
						// Email & Phone Lines
						$row = DirEmailPhoneLines($row);
						$LetterArray[$FirstLetter][$GroupKey]['EmailLine'] = $row['EmailLine'];
						$LetterArray[$FirstLetter][$GroupKey]['PhoneLine'] = $row['PhoneLine'];
				}
		}

		// Sort each letter of the array alphabetically by Name
		foreach($LetterArray as $key => $row)
		{uksort($LetterArray[$key], "strnatcasecmp");}
		// now sort the whole array alphabetically
		uksort($LetterArray, "strnatcasecmp");

		return $LetterArray;
}



function CalcAddressBlockRows($LetterArray, $PDF, $PageVarArray)
{
		foreach($LetterArray as $Letter)
		{
				foreach($Letter as $key => $row)
				{
						// Get first letter from name
						$FirstLetter = strtoupper(substr($row['NameLine'], 0, 1));
						// Calc Rows For Name Line
						$LetterArray[$FirstLetter][$key]['NameLineRowCount'] = CalcRows($PDF, $LetterArray[$FirstLetter][$key]['NameLine'], $PageVarArray['Fonts']['F_Hel_B'], $PageVarArray['FontSize']['NameLine'], $PageVarArray['A_Width']);
						// Calc Rows For Email Line
						$LetterArray[$FirstLetter][$key]['EmailLineRowCount'] = CalcRows($PDF, $LetterArray[$FirstLetter][$key]['EmailLine'], $PageVarArray['Fonts']['F_Hel'], $PageVarArray['FontSize']['TextLine'], $PageVarArray['A_Width']);
						// Calc Rows For Phone Line
						$LetterArray[$FirstLetter][$key]['PhoneLineRowCount'] = CalcRows($PDF, $LetterArray[$FirstLetter][$key]['PhoneLine'], $PageVarArray['Fonts']['F_Hel'], $PageVarArray['FontSize']['TextLine'], $PageVarArray['A_Width']);
						// Calc height of address block
						$LetterArray[$FirstLetter][$key]['BlockHeight'] = ($PageVarArray['FontSize']['NameLineHeight'] *  $LetterArray[$FirstLetter][$key]['NameLineRowCount']) +
																						  ($PageVarArray['FontSize']['NameLineHeight'] * ($LetterArray[$FirstLetter][$key]['EmailLineRowCount'] +
																																		  $LetterArray[$FirstLetter][$key]['PhoneLineRowCount'] +
																																		  1));
				}
		}

		return $LetterArray;
}

function CalcRows($PDF, $Text, $FontName, $FontSize, $MaxLength)
{
		// set return value
		$RowCount = 0;

		if(strlen($Text) > 0)
		{$RowCount = 1;}
		
		// while the length (in pixels, NOT characters) of the Text string is longer than the max. length do the loop.
		while (pdf_stringwidth($PDF, $Text, $FontName, $FontSize) > $MaxLength)
		{
				// increment RowCount
				$RowCount += 1;
				// grab one line of text from the TextRemain
				$TextLine = substr($Text, 0, $MaxLength);
				// lop off characters one at a time until a space is reached
				while (substr($TextLine, -1) != " ")
				{$TextLine = substr($TextLine, 0, -1);}
				// chop the TextLine from the beginning of Text
				$Text = substr($Text, strlen($TextLine));
		}

		return $RowCount;
}

function DirNameLine($row)
{
	// Copy Group Name to a var
	$RowName = $row['Name'];
	$ReturnName = $RowName;
	// need a count down var for the commas & ampersands between names.
	$CountDown = $row['MemberCount'];

	// process each member in the group and add to the line
	foreach($row['Members'] as $Member)
		{
			if ($Member['LName'] == $RowName) // last name equals group name
			{
				if($Member['PName'] || $Member['FName'])
				{$MemberName = MemberInformalName($Member['PName'], $Member['FName'], "", "", $Member['Suffix']);}
				else {$MemberName = '';}
			}
			else // last name is not equal to group name
			{
				if($Member['PName'] || $Member['FName'] || $Member['LName'])
				{$MemberName = MemberInformalName($Member['PName'], $Member['FName'], "", $Member['LName'], $Member['Suffix']);}
				else {$MemberName = '';}
			}
			// put a comma between all names except last one, put an ampersand there. i.e. "1, 2, 3 & 4"
			if(($CountDown >= 2) || ($row['MemberCount'] == 1) && $MemberName != '')
			{$ReturnName .= ", ".$MemberName;}
			elseif(($CountDown == 1) && $MemberName != '')
			{$ReturnName .= " & ".$MemberName;}

			$CountDown -= 1;
		} // end foreach

	return $ReturnName;
}

function MemberInformalName($M_PName, $M_FName, $M_MName, $M_LName, $M_Suffix)
{
	$MemberName = "";
	if ($M_PName)
	{
		$MemberName .= $M_PName;
	}
	elseif ($M_FName)
	{
		$MemberName .= $M_FName;
	}
	if ($M_MName && ($M_MName != $M_PName))
	{
		$MemberName .= ' '.$M_MName;
	}
	if ($M_LName)
	{
		$MemberName .= ' '.$M_LName;
	}
	if ($M_Suffix)
	{
		$MemberName .= ', '.$M_Suffix;
	}
	return $MemberName;
}

function DirCityStateZipLine($row)
{
	if($row['City'] != ''){$CSZ = $row['City'];}

	if((isset($CSZ)) && ($row['StateTwoLetter'] != '')) {$CSZ .= " ";}
	if($row['StateTwoLetter'] != ''){$CSZ .= $row['StateTwoLetter'];}

	if((isset($CSZ)) && ($row['Region'] != '')) {$CSZ .= " ";}
	if($row['Region'] != ''){$CSZ .= $row['Region'];}

	if((isset($CSZ)) && ($row['Zip'] != '')) {$CSZ .= " ";}
	if(($row['Zip'] != '') && ($row['Country'] == 'USA')){$CSZ .= substr($row['Zip'], 0, 5);}
	else{$CSZ .= $row['Zip'];}

	if((isset($CSZ)) && ($row['Country'] != '') && ($row['Country'] != 'USA')){$CSZ .= " ";}
	if(($row['Country'] != '') && ($row['Country'] != 'USA')){$CSZ .= $row['Country'];}

	return $CSZ;
}

function DirEmailPhoneLines($row)
{
	// process contacts to pull out emails and home phone (if they exist) and put into array
	if($row['Contacts'])
	{
		foreach($row['Contacts'] as $Contact)
		{
			if($Contact['ContactType'] == 'Email')
			{$EmailArray[$Contact['ContactID']] = array('Name' => $Contact['ContactName'], 'Email' => $Contact['ContactInfo']);}
			if($Contact['ContactType'] == 'Home Phone')
			{$PhoneArray[$Contact['ContactID']] = array('Name' => $Contact['ContactName'], 'Phone' => $Contact['ContactInfo']);}
		}// end foreach
	}

	// process email array
	if($EmailArray)
	{
		foreach($EmailArray as $EMA)
		{
			if(empty($row['EmailLine'])){$row['EmailLine'] = $EMA['Email'];}
			else{$row['EmailLine'] .= ", ".$EMA['Email'];}
		}
	}

	// process phone array
	if($PhoneArray)
	{
		foreach($PhoneArray as $PA)
		{
			if(empty($row['PhoneLine'])){$row['PhoneLine'] = $PA['Phone'];}
			else{$row['PhoneLine'] .= ", ".$PA['Phone'];}
		}
	}

	return $row;
}

function SetFirstLastColumnAddress($PageVarArray, $ColumnArray, $ColumnNumber)
{
	$ColumnFirstName = "Col".$ColumnNumber."_FirstName";
	$ColumnLastName = "Col".$ColumnNumber."_LastName";

	// first name
	if ($PageVarArray[$ColumnFirstName] == '')
	{
			$CurrentBlock = current($ColumnArray);
			$PageVarArray[$ColumnFirstName] = $CurrentBlock['LastName'];
	}
	// last name
	$PageVarArray[$ColumnLastName] = $ColumnArray[LastArrayElementKey($ColumnArray)]['LastName'];

	return $PageVarArray;
}

?>