<?php

function PDF_Create($Author, $Title, $Creator, $Subject)  // create the basic PDF construct
{
	$pdf = pdf_new();
	pdf_open_file($pdf, '');

	if($Author !=''){pdf_set_info($pdf, "Author", $Author);}
	if($Title !=''){	pdf_set_info($pdf, "Title", $Title);}
	if($Creator !=''){	pdf_set_info($pdf, "Creator", $Creator);}
	if($Subject !=''){	pdf_set_info($pdf, "Subject", $Subject);}
	
	return $pdf;	
}


function PDF_Page($Size, $MarginL, $MarginR, $MarginT, $MarginB) // define the page size and elements (margins, etc.)
{
	switch ($Size)
	{
		case 1 : // letter
		{
			$Width = 612;
			$Height = 792;
			break;
		}
		case 2 : // letter, portrait
		{
			$Width = 792;
			$Height = 612;
			break;
		}
		// other cases can be added as needed - envelopes!
	}
	
	$P_Width = $Width - $MarginL - $MarginR;
	$P_Height = $Height = $MarginT - $MarginB;
	
	return array($Width, $Height, $P_Width, $P_Height);
}


function PDF_CloseOut($pdf, $Filename, $AorI) // Close and output the PDF  (AorI = attachment or inline)
{
	pdf_close($pdf);
	$output = pdf_get_buffer($pdf);
	$x = File_CloseOut($output, $AorI, $Filename, "application/pdf");
	return $output;
}


function File_CloseOut($output, $AorI, $Filename, $ContentType) // Close and output the file  (AorI = attachment or inline)
{
	$Len = strlen($output);
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
 	header("Cache-Control: no-store, no-cache, must-revalidate");
	header("Cache-Control: post-check=0, pre-check=0", false);
	header("Pragma: no-cache");
	header("Cache-control: private");
	header("Content-Type: ".$ContentType);
	header("Content-Length: ".$Len);
	header("Content-Disposition: ".$AorI."; filename= ".$Filename);
}


function WhiteBox($pdf, $X, $Y, $Width, $Height)
{
	pdf_setcolor($pdf, "fill", "rgb", 1, 1, 1, 0);
	pdf_rect($pdf, $X, $Y, $Width, $Height);
	pdf_fill_stroke($pdf);
	pdf_setcolor($pdf, "fill", "rgb", 0, 0, 0, 0);
	return $pdf;
}

function Box($pdf, $X, $Y, $Width, $Height, $F_R=1, $F_G=1, $F_B=1, $S_R=0, $S_G=0, $S_B=0) // default is a box with white fill and black line.
{
	pdf_setcolor($pdf, "fill", "rgb", $F_R, $F_G, $F_B, 0);
	pdf_setcolor($pdf, "stroke", "rgb", $S_R, $S_G, $S_B, 0);
	pdf_rect($pdf, $X, $Y, $Width, $Height);
	pdf_fill_stroke($pdf);
	pdf_setcolor($pdf, "fill", "rgb", 0, 0, 0, 0);
	pdf_setcolor($pdf, "stroke", "rgb", 0, 0, 0, 0);
	return $pdf;
}

function DrawLine($pdf, $X1, $Y1, $X2, $Y2)
{
	pdf_moveto($pdf, $X1, $Y1);
	pdf_lineto($pdf, $X2, $Y2);
	pdf_stroke($pdf);
	return $pdf;
}

?>