<?php

// Sends a renewal email or returns an error flag
function RenewEmail($row, $Message, $RenewMonth, $RenewYear, $Globals, $NoEmailSentArray, $EmailSentArray)
{
		// reset vars
		$Email = '';
		$pdf = '';
		
		$EmailFlag = ''; // if = 1, email is sent. If empty, failure.

		// if there are contacts at all
		if($row['Contacts'])
		{
				// build email list
				foreach($row['Contacts'] as $Contact)
				{
						// but only if the contact is of type "Email"
						if($Contact['ContactType'] == 'Email')
						{
								if ($Email != ''){$Email .= ", ";}
								$Email .= $Contact['ContactInfo'];
						}
				}// end build email list
		}// end if row contacts
		else // this "else" can be removed when testing is complete. *************************************************
		{
				// do nothing
				echo"NO Contacts!<br />";			
		}

		// if email
		if ($Email != '')
		{
			// this line can be removed when testing is complete. ******************************************************
			echo $Email."<br />";

			// build the renewal form.
				// create renewal pdf
				$pdf = PDF_Create("", $Globals['ClubNameShort']."_Renewal_".$row['FamOrgID']."_".$RenewYear."_".$RenewMonth, "", "");
				// give it a filename
				$Filename = $Globals['ClubNameShort']."_Renewal_".$row['FamOrgID']."_".$RenewYear."_".$RenewMonth.".pdf";
				// build the mailing address
				list($Adr, $line) = BuildMailingLabelAddress($row);
				// make the actual page
				$pdf = PDF_RenewalLetter($pdf, $Adr, $row);
				// close out the pdf
				pdf_close($pdf);
				$Attachment = pdf_get_buffer($pdf);

			// send the email.
//				$Message = $Message."  ".$Email;
				$output = Mail_Attach($Email, $Globals['MembershipCoordinatorEmail'], $Globals['ClubNameShort']." Renewal Reminder", $Message, $Attachment, $Filename);
				// if error, add basic info - group ID, name, expiration date to a "not sent list"
				// if no error, add basic info - group ID, name, expiration date to a "sent list"
				if($output == true){$EmailFlag = '1';}
		}
		// if no email
		else
		{
			// this line can be removed when testing is complete. ******************************************************
			echo "Contacts but no email!<br />";
			// add basic info - group ID, name, expiration date to a "not sent list"
		}

		//check for email flag
		if($EmailFlag != '1') {$NoEmailSentArray[] = $row;}
		else {$EmailSentArray[] = $row;}

		$ResultArray = array($NoEmailSentArray, $EmailSentArray);
		// return the result
		return $ResultArray;
}

function ComputeSalutation($row)
{
		// since there are only 2 cases (family or org AND all others), an if is easy here. if diversity increases, change to a switch.
		if($row['MemberType'] == "Family" || $row['MemberType'] == "Organization")
		{
				if($row['Name'])
				{
						$Salutation = $row['Name'];
						if($row['MemberType'] == "Family"){$Salutation .= " Family";}
				}
				else {$Salutation = "Friend";}
				
		}
		else // everyone BUT Family or Organization - assumes only 1 member.
		{
				// if this is true, it might be an error condition.
				if(count($row['Members']) > 1){$Salutation = "Friend";}
				else
				{
						foreach($row['Members'] as $Member)
						{
								if($Member['PName']){$Salutation = $Member['PName'];}
								elseif($Member['FName']){$Salutation = $Member['FName'];}
								elseif($Member['LName'])
								{
										if($Member['Gender'] == 'M')
										{$Salutation = "Mr. ".$Member['LName'];}
										elseif($Member['Gender'] == 'F')
										{$Salutation = "Ms. ".$Member['LName'];}
										else
										{$Salutation = "Friend";}
								}
	
								else{$Salutation = "Friend";}
						}
								
				}
		} // end the everyone but family and org if/else
		
		return $Salutation;
}

function ResultsEmail($To, $From, $Subject, $NoEmailSentArray, $EmailSentArray)
{

		// make the email message a template with replaceable parts - i.e. ['NoEmailList'] and such.

		// message header (will become part of template)
		$ResultMessage =	"\r\n --------------------------------------------------\r\n".
							" |  No emails were sent to:                       |\r\n".
							" --------------------------------------------------\r\n";

		// create list of members no email was sent to
		foreach($NoEmailSentArray as $row)
		{
				$Spaces = ResultsSpaces($row['FamOrgID']);
				$ResultMessage .= $Spaces.$row['FamOrgID']."  ".$row['Name']."\r\n";
		}
		$ResultMessage .=	"\r\n --------------------------------------------------\r\n".
							" |  Emails were sent to:                          |\r\n".
							" --------------------------------------------------\r\n";

		// create list of members email was sent to
		foreach($EmailSentArray as $row)
		{
				$Spaces = ResultsSpaces($row['FamOrgID']);
				$ResultMessage .= $Spaces.$row['FamOrgID']."  ".$row['Name']."\r\n";
		}

		// message footer (will become part of template)
		$ResultMessage .= "\r\n --------------------------------------------------\r\n";

		// send the email.
		$output = Mail_NoAttach($To, $From, $Subject, $ResultMessage);

		return $output;
}

function ResultsSpaces($Number)
{
		$Spaces = " ";

		if ($Number <100000){$Spaces.=" ";}
		if ($Number <10000){$Spaces.=" ";}
		if ($Number <1000){$Spaces.=" ";}
		if ($Number <100){$Spaces.=" ";}
		if ($Number <10){$Spaces.=" ";}

		return $Spaces;
}

?>