<?php

function StatsDataQuery()  // Get the data from the db and put into an array. Return the array
{
	$query = "SELECT Member.Gender, Member.DOB, LEFT(FamOrg.Zip, 5) AS Zip, FamOrg.StateTwoLetter, FamOrg.MemberTypeID, MemberType.MemberType
			  FROM Member
			  LEFT JOIN FamOrg ON (Member.FamOrgID = FamOrg.FamOrgID)
			  LEFT JOIN MemberType ON (FamOrg.MemberTypeID = MemberType.MemberTypeID)
			  WHERE FamOrg.FamOrgArchive != 1
			  ORDER BY Member.DOB ASC";
	
	$result = mysql_query($query);
	$i = 1;
	while($row = mysql_fetch_array($result))
	{
		foreach($row as $key => $val)
		{$$key = stripslashes($val);}

		// calculate age
//		$Age = Convert_DOB_to_Age($DOB);
		if($DOB != '0000-00-00')
		{$Age = Convert_DOB_to_Age($DOB);}
		else
		{$Age = -1;}

		// add row to array
		$StatsDataArray[$i] = array('Gender' => $Gender, 'DOB' => $DOB, 'Age' => $Age, 'Zip' => $Zip,
								'StateTwoLetter' => $StateTwoLetter, 'MemberTypeID' => $MemberTypeID, 'MemberType' =>$MemberType);

		// increment the counter
		$i += 1;
	}

	return $StatsDataArray;
}


function StatsCalc($StatsDataArray)
{

	// StatsInfoArray1 = [State][Age Group][Gender]
	// StatsInfoArray2 = [State][MemberTypeID]
	// StatsInfoArray3 = [Zip][County][State] <-- later will add in city & state

	foreach($StatsDataArray as $row)
	{
		// Set the age group
		if($row['Age'] < 0)
		{$AG = 'Unknown';}
		elseif($row['Age'] < 15)
		{$AG = 'AG0014';}
		elseif ($row['Age'] < 20)
		{$AG = 'AG1519';}
		elseif ($row['Age'] < 25)
		{$AG = 'AG2024';}
		elseif ($row['Age'] < 30)
		{$AG = 'AG2529';}
		elseif ($row['Age'] < 35)
		{$AG = 'AG3034';}
		elseif ($row['Age'] < 40)
		{$AG = 'AG3539';}
		elseif ($row['Age'] < 45)
		{$AG = 'AG4044';}
		elseif ($row['Age'] < 50)
		{$AG = 'AG4549';}
		elseif ($row['Age'] < 55)
		{$AG = 'AG5054';}
		elseif ($row['Age'] < 60)
		{$AG = 'AG5559';}
		elseif ($row['Age'] < 65)
		{$AG = 'AG6064';}
		elseif ($row['Age'] < 70)
		{$AG = 'AG6569';}
		elseif ($row['Age'] < 75)
		{$AG = 'AG7074';}
		elseif ($row['Age'] < 80)
		{$AG = 'AG7579';}
		elseif ($row['Age'] >79)
		{$AG = 'AG80up';}
//		else
//		{$AG = 'Unknown';}

		// Set Gender group  <---- this needs to be redone as an if/then statement.
		switch($row['Gender'])
		{
			case 'M' :
				$G = 'M';
				break;
			case 'F' :
				$G = 'F';
				break;
			default :
				$G = 'X';
		}

		// Set state group
		if($row['StateTwoLetter'] != 'DC' && $row['StateTwoLetter'] != 'VA' && $row['StateTwoLetter'] != 'MD')
		{$S = 'Other';}
		else
		{$S = $row['StateTwoLetter'];}

		// StatsInfoArray1 = [State][Age Group][Gender]
		// StatsInfoArray2 = [State][MemberTypeID] <-- later will add in MemberType
 		// StatsInfoArray3 = [Zip][County][State] <-- later will add in city & state

		$StatsInfoArray1[$S][$AG][$G] += 1;
		$StatsInfoArray2[$S][$row['MemberTypeID']] += 1;
		$StatsInfoArray3[$row['Zip']]['Count'] += 1; //later will add city & state

		if(!$StatsInfoArray3[$row['Zip']]['City'])
		{$StatsInfoArray3[$row['Zip']]['City'] = $row['City'];}
		
		if(!$StatsInfoArray3[$row['Zip']]['StateTwoLetter'])
		{$StatsInfoArray3[$row['Zip']]['StateTwoLetter'] = $S;}
		
	}

	// add in statistical stuff
	$AG_Array = array("AG0014", "AG1519", "AG2024", "AG2529", "AG3034", "AG3539", "AG4044", "AG4549", "AG5054", "AG5559", "AG6064", "AG6569", "AG7074", "AG7579", "AG80up", "Unknown");
	$G_Array = array("M", "F", "X");
	$S_Array = array("DC", "MD", "VA", "Other");
	$MemberTypeArray = Set_MemberTypeArray();

	foreach ($MemberTypeArray as $MTA)
	{
		$MT_Array[] = array(MemberTypeID => $MTA['MemberTypeID'], MemberType => $MTA['MemberType']);
	}

	// the below loops add in a new row (Total) to each array dimension for StatsInfoArray1. Each new row has several vars:
	// Total
	// M, F, X (a count)
	// M_Prcnt, F_Prcnt, X_Prcnt (a percentage)

	foreach($S_Array as $S) // loop through states
	{
		foreach($AG_Array as $AG) // loop through age groups
		{
			foreach($G_Array as $G) // loop through genders to get total of each age group (M + F + X)
			{
				if($StatsInfoArray1[$S][$AG][$G])
				{
					// total by state :: age group
					$StatsInfoArray1[$S][$AG]['Total'] += $StatsInfoArray1[$S][$AG][$G];
					// total by state
					$StatsInfoArray1[$S]['Total']['Total'] += $StatsInfoArray1[$S][$AG][$G]; // $StatsInfoArray1[$S]['Total'][$G];
					// total by state (gender)
					$StatsInfoArray1[$S]['Total'][$G] += $StatsInfoArray1[$S][$AG][$G]; // $StatsInfoArray1[$S][$AG][$G];					
					// total of all
					$StatsInfoArray1['Total']['Total'] += $StatsInfoArray1[$S][$AG][$G]; // $StatsInfoArray1[$S]['Total'][$G];
					// total by age group & gender
					$StatsInfoArray1[$AG][$G] += $StatsInfoArray1[$S][$AG][$G];
					// total of all (age group)
					$StatsInfoArray1['Total'][$AG] += $StatsInfoArray1[$S][$AG][$G];
					// total of all (gender)
					$StatsInfoArray1['Total'][$G] += $StatsInfoArray1[$S][$AG][$G]; // $StatsInfoArray1[$S]['Total'][$G];
				}
			}

			foreach($G_Array as $G) // loop through gender to calc % by age group
			{
				if($StatsInfoArray1[$S][$AG]['Total'] < 1)
				{$StatsInfoArray1[$S][$AG][$G.'_Prcnt'] = 0;}
				else
				{
					$StatsInfoArray1[$S][$AG][$G.'_Prcnt'] = round(($StatsInfoArray1[$S][$AG][$G]/$StatsInfoArray1[$S][$AG]['Total'])*100);
				}
			}
		}
		
		foreach($G_Array as $G) // loop through gender to calc % by state
		{
			if($StatsInfoArray1[$S]['Total']['Total'] < 1)
			{$StatsInfoArray1[$S]['Total'][$G.'_Prcnt'] = 0;}
			else
			{
				$StatsInfoArray1[$S]['Total'][$G.'_Prcnt'] = round(($StatsInfoArray1[$S]['Total'][$G]/$StatsInfoArray1[$S]['Total']['Total'])*100);
			}
		}	
	}
	foreach($G_Array as $G) // loop through gender to calc % overall
	{
		if($StatsInfoArray1['Total']['Total'] < 1)
		{$StatsInfoArray1['Total'][$G.'_Prcnt'] = 0;}
		else
		{
			$StatsInfoArray1['Total'][$G.'_Prcnt'] = round(($StatsInfoArray1['Total'][$G]/$StatsInfoArray1['Total']['Total'])*100);
		}
	}
	foreach($AG_Array as $AG) // loop through Age Groups to calc % overall
	{
		if($StatsInfoArray1['Total'][$AG] < 1)
		{$StatsInfoArray1['Total'][$AG.'_Prcnt'] = 0;}
		else
		{
			$StatsInfoArray1['Total'][$AG.'_Prcnt'] = round(($StatsInfoArray1['Total'][$AG]/$StatsInfoArray1['Total']['Total'])*100);
		}
	}
	foreach($S_Array as $S) // loop through States to calc % overall
	{
		if($StatsInfoArray1[$S]['Total']['Total'] < 1)
		{$StatsInfoArray1['Total'][$S.'_Prcnt'] = 0;}
		else
		{
			$StatsInfoArray1['Total'][$S.'_Prcnt'] = round(($StatsInfoArray1[$S]['Total']['Total']/$StatsInfoArray1['Total']['Total'])*100);
		}
	}


	// The below loops add in Totals for StatsInfoArray2
	// StatsInfoArray2 = [State][MemberType] <-- later will add in MemberType

	foreach($S_Array as $S)
	{
//		foreach($MemberTypeArray['MemberTypeID'] as $MT) // get the total members in each state (DC, MD, VA, XX)
		foreach($MT_Array as $MT) // get the total members in each state (DC, MD, VA, XX)
		{
			if($StatsInfoArray2[$S][$MT['MemberTypeID']])
			{
				$StatsInfoArray2[$S]['Total']['Total'] += $StatsInfoArray2[$S][$MT['MemberTypeID']];
				$StatsInfoArray2['Total']['Total'] += $StatsInfoArray2[$S][$MT['MemberTypeID']];
				$StatsInfoArray2['Total'][$MT['MemberTypeID']] += $StatsInfoArray2[$S][$MT['MemberTypeID']];
			}
		}

//		foreach($MemberTypeArray['MemberTypeID'] as $MT) // calculate the %'s by member type by state
		foreach($MT_Array as $MT) // calculate the %'s by member type by state
		{
			if($StatsInfoArray2[$S]['Total']['Total'] < 1)
			{$StatsInfoArray2[$S]['Total'][$MT['MemberTypeID'].'_Prcnt'] = 0;}
			else
			{
				$StatsInfoArray2[$S]['Total'][$MT['MemberTypeID'].'_Prcnt'] = round(($StatsInfoArray2[$S][$MT['MemberTypeID']]/$StatsInfoArray2[$S]['Total']['Total'])*100);
			}
			if($StatsInfoArray2['Total']['Total'] < 1)
			{$StatsInfoArray2['Total'][$MT['MemberTypeID'].'_Prcnt'] = 0;}
			else
			{
				$StatsInfoArray2['Total'][$MT['MemberTypeID'].'_Prcnt'] = round(($StatsInfoArray2['Total'][$MT['MemberTypeID']]/$StatsInfoArray2['Total']['Total'])*100);
			}
		}
	}

	// The below lops add in Totals for StatsInfoArray3
	// StatsInfoArray3 = [Zip][County][State] <-- later will add in city & state


	return array($StatsInfoArray1, $StatsInfoArray2, $StatsInfoArray3);
}

function BuildGenderTable($StatsInfoArray1, $TableHead, $TableRepeat, $TableFoot)
{
	// build needed arrays
	$G_Array = array("M" => "Male", "F" => "Female", "X" => "Unknown");

	// head
	$GenderTable = $TableHead;
	$GenderTable = str_replace( "['TableName']", 'Gender', $GenderTable);
	$GenderTable = str_replace( "['Col1Name']", 'Gender', $GenderTable);
	$GenderTable = str_replace( "['Col2Name']", 'Count', $GenderTable);
	$GenderTable = str_replace( "['Col3Name']", 'Percent', $GenderTable);

	// body
	foreach($G_Array as $G => $G_Formatted)
	{
		$RepeatSection = $TableRepeat;
		$RepeatSection = str_replace( "['Col1Data']", $G_Formatted, $RepeatSection);
		$RepeatSection = str_replace( "['Col2Data']", $StatsInfoArray1['Total'][$G], $RepeatSection);
		$RepeatSection = str_replace( "['Col3Data']", $StatsInfoArray1['Total'][$G.'_Prcnt'], $RepeatSection);

		$GenderTable .= $RepeatSection;
	}

	// foot
	$GenderTable .= $TableFoot;
	$GenderTable = str_replace( "['Col2Total']", $StatsInfoArray1['Total']['Total'], $GenderTable);
	$GenderTable = str_replace( "['Col3Total']", '100', $GenderTable); // can either make this a calc or hard code it(?)

	return $GenderTable;
}


function BuildStateTable($StatsInfoArray1, $TableHead, $TableRepeat, $TableFoot)
{
	// build needed arrays
	$S_Array = array("DC", "MD", "VA", "Other");

	// head
	$StateTable = $TableHead;
	$StateTable = str_replace( "['TableName']", 'State', $StateTable);
	$StateTable = str_replace( "['Col1Name']", 'State', $StateTable);
	$StateTable = str_replace( "['Col2Name']", 'Count', $StateTable);
	$StateTable = str_replace( "['Col3Name']", 'Percent', $StateTable);

	// body
	foreach($S_Array as $S)
	{
		$RepeatSection = $TableRepeat;
		$RepeatSection = str_replace( "['Col1Data']", $S, $RepeatSection);
		$RepeatSection = str_replace( "['Col2Data']", $StatsInfoArray1[$S]['Total']['Total'], $RepeatSection);
		$RepeatSection = str_replace( "['Col3Data']", $StatsInfoArray1['Total'][$S.'_Prcnt'], $RepeatSection);

		$StateTable .= $RepeatSection;
	}

	// foot
	$StateTable .= $TableFoot;
	$StateTable = str_replace( "['Col2Total']", $StatsInfoArray1['Total']['Total'], $StateTable);
	$StateTable = str_replace( "['Col3Total']", '100', $StateTable); // can either make this a calc or hard code it(?)

	return $StateTable;
}


function BuildMemberTable($StatsInfoArray1, $StatsInfoArray2, $TableHead, $TableRepeat, $TableFoot)
{
	// build needed arrays
	$MemberTypeArray = Set_MemberTypeArray();

	foreach ($MemberTypeArray as $MTA)
	{
		$MT_Array[] = array(MemberTypeID => $MTA['MemberTypeID'], MemberType => $MTA['MemberType']);
	}

	// head
	$MemberTable = $TableHead;
	$MemberTable = str_replace( "['TableName']", 'Member Type', $MemberTable);
	$MemberTable = str_replace( "['Col1Name']", 'Member Type', $MemberTable);
	$MemberTable = str_replace( "['Col2Name']", 'Count', $MemberTable);
	$MemberTable = str_replace( "['Col3Name']", 'Percent', $MemberTable);

	// body
	foreach($MT_Array as $MT)
	{
		$RepeatSection = $TableRepeat;
		$RepeatSection = str_replace( "['Col1Data']", $MT['MemberType'], $RepeatSection);
		$RepeatSection = str_replace( "['Col2Data']", $StatsInfoArray2['Total'][$MT['MemberTypeID']], $RepeatSection);
		$RepeatSection = str_replace( "['Col3Data']", $StatsInfoArray2['Total'][$MT['MemberTypeID'].'_Prcnt'], $RepeatSection);

		$MemberTable .= $RepeatSection;
	}

	// foot
	$MemberTable .= $TableFoot;
	$MemberTable = str_replace( "['Col2Total']", $StatsInfoArray2['Total']['Total'], $MemberTable);
	$MemberTable = str_replace( "['Col3Total']", '100', $MemberTable); // can either make this a calc or hard code it(?)

	return $MemberTable;
}


function BuildAgeGenderTable($StatsInfoArray1, $TableHead, $TableRepeat, $TableFoot)
{
	// build needed arrays
	$AG_Array = array("AG0014" => 'Under 15', "AG1519" => '15 to 19', "AG2024" => '20 to 24', "AG2529" => '25 to 29', "AG3034" => '30 to 34', "AG3539" => '35 to 39', "AG4044" => '40 to 44', "AG4549" => '45 to 49', "AG5054" => '50 to 54', "AG5559" => '55 to 59', "AG6064" => '60 to 64', "AG6569" => '65 to 69', "AG7074" => '70 to 74', "AG7579" => '75 to 79', "AG80up" => '80 and higher', "Unknown" => 'Unknown');

	// head
	$AGTable = $TableHead;
	$AGTable = str_replace( "['TableName']", 'Age Group &amp; Gender', $AGTable);
	$AGTable = str_replace( "['Col1Name']", 'Age Group', $AGTable);
	$AGTable = str_replace( "['Col2Name']", 'Male', $AGTable);
	$AGTable = str_replace( "['Col3Name']", 'Female', $AGTable);
	$AGTable = str_replace( "['Col4Name']", 'Unknown', $AGTable);
	$AGTable = str_replace( "['Col5Name']", 'Total', $AGTable);
	$AGTable = str_replace( "['Col6Name']", 'Percent', $AGTable);

	// body
	foreach($AG_Array as $AG => $AG_Formatted)
	{	
		$RepeatSection = $TableRepeat;
		$RepeatSection = str_replace( "['Col1Data']", $AG_Formatted, $RepeatSection);
		$RepeatSection = str_replace( "['Col2Data']", $StatsInfoArray1[$AG]['M'], $RepeatSection);
		$RepeatSection = str_replace( "['Col3Data']", $StatsInfoArray1[$AG]['F'], $RepeatSection);
		$RepeatSection = str_replace( "['Col4Data']", $StatsInfoArray1[$AG]['X'], $RepeatSection);
		$RepeatSection = str_replace( "['Col5Data']", ($StatsInfoArray1[$AG]['M'] + $StatsInfoArray1[$AG]['F'] + $StatsInfoArray1[$AG]['X']), $RepeatSection);
		$RepeatSection = str_replace( "['Col6Data']", $StatsInfoArray1['Total'][$AG.'_Prcnt']."%", $RepeatSection);

		$AGTable .= $RepeatSection;
	}

	// foot
	$AGTable .= $TableFoot;
	$AGTable = str_replace( "['Col2Total']", $StatsInfoArray1['Total']['M'], $AGTable);
	$AGTable = str_replace( "['Col3Total']", $StatsInfoArray1['Total']['F'], $AGTable);
	$AGTable = str_replace( "['Col4Total']", $StatsInfoArray1['Total']['X'], $AGTable);
	$AGTable = str_replace( "['Col5Total']", $StatsInfoArray1['Total']['M'] + $StatsInfoArray1['Total']['F'] + $StatsInfoArray1['Total']['X'], $AGTable);
	$AGTable = str_replace( "['Col6Total']", '100%', $AGTable); // can either make this a calc or hard code it(?)

	return $AGTable;
}


function BuildAgeStateTable($StatsInfoArray1, $TableHead, $TableRepeat, $TableFoot)
{
	// build needed arrays
	$AG_Array = array("AG0014" => 'Under 15', "AG1519" => '15 to 19', "AG2024" => '20 to 24', "AG2529" => '25 to 29', "AG3034" => '30 to 34', "AG3539" => '35 to 39', "AG4044" => '40 to 44', "AG4549" => '45 to 49', "AG5054" => '50 to 54', "AG5559" => '55 to 59', "AG6064" => '60 to 64', "AG6569" => '65 to 69', "AG7074" => '70 to 74', "AG7579" => '75 to 79', "AG80up" => '80 and higher', "Unknown" => 'Unknown');

	// head
	$ASTable = $TableHead;
	$ASTable = str_replace( "['TableName']", 'Age Group &amp; State', $ASTable);
	$ASTable = str_replace( "['Col1Name']", 'Age Group', $ASTable);
	$ASTable = str_replace( "['Col2Name']", 'DC', $ASTable);
	$ASTable = str_replace( "['Col3Name']", 'MD', $ASTable);
	$ASTable = str_replace( "['Col4Name']", 'VA', $ASTable);
	$ASTable = str_replace( "['Col5Name']", 'Other', $ASTable);
	$ASTable = str_replace( "['Col6Name']", 'Total', $ASTable);
	$ASTable = str_replace( "['Col7Name']", 'Percent', $ASTable);

	// body
	foreach($AG_Array as $AG => $AG_Formatted)
	{	
		$RepeatSection = $TableRepeat;
		$RepeatSection = str_replace( "['Col1Data']", $AG_Formatted, $RepeatSection);
		$RepeatSection = str_replace( "['Col2Data']", $StatsInfoArray1['DC'][$AG]['Total'], $RepeatSection);
		$RepeatSection = str_replace( "['Col3Data']", $StatsInfoArray1['MD'][$AG]['Total'], $RepeatSection);
		$RepeatSection = str_replace( "['Col4Data']", $StatsInfoArray1['VA'][$AG]['Total'], $RepeatSection);
		$RepeatSection = str_replace( "['Col5Data']", $StatsInfoArray1['Other'][$AG]['Total'], $RepeatSection);
		$RepeatSection = str_replace( "['Col6Data']", ($StatsInfoArray1['DC'][$AG]['Total'] + $StatsInfoArray1['MD'][$AG]['Total'] + $StatsInfoArray1['VA'][$AG]['Total'] + $StatsInfoArray1['Other'][$AG]['Total']), $RepeatSection);
		$RepeatSection = str_replace( "['Col7Data']", $StatsInfoArray1['Total'][$AG.'_Prcnt']."%", $RepeatSection);

		$ASTable .= $RepeatSection;
	}

	// foot
	$ASTable .= $TableFoot;
	$ASTable = str_replace( "['Col2Total']", $StatsInfoArray1['DC']['Total']['Total']."<br />(".$StatsInfoArray1['Total']['DC_Prcnt']."%)", $ASTable);
	$ASTable = str_replace( "['Col3Total']", $StatsInfoArray1['MD']['Total']['Total']."<br />(".$StatsInfoArray1['Total']['MD_Prcnt']."%)", $ASTable);
	$ASTable = str_replace( "['Col4Total']", $StatsInfoArray1['VA']['Total']['Total']."<br />(".$StatsInfoArray1['Total']['VA_Prcnt']."%)", $ASTable);
	$ASTable = str_replace( "['Col5Total']", $StatsInfoArray1['Other']['Total']['Total']."<br />(".$StatsInfoArray1['Total']['Other_Prcnt']."%)", $ASTable);
	$ASTable = str_replace( "['Col6Total']", $StatsInfoArray1['Total']['Total']."<br />&nbsp;", $ASTable);
	$ASTable = str_replace( "['Col7Total']", "100%<br />&nbsp;", $ASTable); // can either make this a calc or hard code it(?)

	return $ASTable;
}


function BuildStatsCSV($StatsDataArray)
{

	// Add in the Header row
	$StatsCSV = "GENDER, DOB, AGE, ZIP, STATE, MEMBERTYPE\n";
	$SQ = '"'; // a single double-quote
	$FS = '","'; // field seperation
	$LB = "\n"; // line (row) break

	// build the row
	foreach($StatsDataArray as $row)
	{
		$StatsCSV .= $SQ.$row['Gender'];
		$StatsCSV .= $FS.$row['DOB'];
		$StatsCSV .= $FS.$row['Age'];
		$StatsCSV .= $FS.$row['Zip'];
		$StatsCSV .= $FS.$row['StateTwoLetter'];
		$StatsCSV .= $FS.$row['State'];
		$StatsCSV .= $FS.$row['MemberType'].$SQ;
		$StatsCSV .= $LB;
	}

	// compress the string into a gzip format
	$StatsCSV = gzencode($StatsCSV, 9);

	return $StatsCSV;
}

?>