<?php

// There's a lot here that needs explanation & refinement... Here's some documentation to start:
//
// Previous is an HTML string for the "previous" link
// Next is an HTML string for the "Next" link
//
// PreviousNoLink is the HTML string to use if "previous" is not a link (i.e. there are no previous records)
// NextNoLink is the HTML string to use if "next" is not a link (i.e. there are no next records)
//
// CurrentS = current record # - is NOT zero based
// CurrentS_Z = current record # - IS zero based
//
// CurrentL = # of records to show
//
// TotalRecords = total record number
//
// S_Plus_L_View = the Y in "showing X - Y of Z records"
//
// Previous_S = the record # to start from for the previous page.
// Previous_L_V = the record count to show for the previous page (i.e. the X in "previous X")
//
// Next_S = the record # to start from for the next page.
// Next_L_V = the record count to show for the next page (i.e. the X in "next X")


function RecordNavBar($NavBar, $NavBar_LeftDiv, $NavBar_CenterDiv, $NavBar_RightDiv, $CurrentS, $CurrentL, $TotalRecords, $FormAction)
{

	$Previous = "<a href=\"['FormAction']?P=['P']&S=['Previous_S']\">Previous ['Previous_L_V']</a>";
	$Next = "<a href=\"['FormAction']?P=['P']&S=['Next_S']\">Next ['Next_L_V']</a>";
	$PreviousNoLink = "Previous&nbsp;&nbsp;&nbsp;";
	$NextNoLink = "Next&nbsp;&nbsp;&nbsp;";

	$CurrentS_Z = CalcVar_Z($CurrentS);

	// Set Previous
	if ($CurrentS == 1)  // if CurrentS = 1 then we don't want a "previous" link.
	{$Previous = $PreviousNoLink;}
	elseif(($CurrentS_Z - $CurrentL) > 0)  // if we can fit an entire set of L records in, do it.
	{
		$Previous_S = ($CurrentS - $CurrentL);
		$Previous_L_V = $CurrentL;
	}
	else  // if we can't fit an entire set of L records, just set Previous_S to 1 (first record)
	{
		$Previous_S = 1;
		$Previous_L_V = ($CurrentS - 1);
	}

	// Set Next
	if (($CurrentS_Z + $CurrentL*2) >= $TotalRecords)  // if there aren't enough records to fill an entire L set into the next page do this
	{
		if (($TotalRecords - ($CurrentS_Z + $CurrentL)) > 0)  // If there is a partial L set do this
		{
			$Next_S = ($CurrentS + $CurrentL);
			$Next_L_V = ($TotalRecords - $Next_S + 1);
		}
		else {$Next = $NextNoLink;} // if there is no partial set, we're at the last record and we don't want a "next" link
	}
	else  // if there are enough records to make a whole L set, do it.
	{
		$Next_S = ($CurrentS + $CurrentL);
		$Next_L_V = $CurrentL;
	}

	// Set the Y in "X - Y of Z records"
	if (($CurrentS_Z + $CurrentL) >= $TotalRecords)
	{$S_Plus_L_View = $TotalRecords;}
	else {$S_Plus_L_View = ($CurrentS + $CurrentL - 1);}

	// Do the sub-string replacements
	if ($Previous != $PreviousNoLink)
	{
		$Previous = str_replace("['Previous_S']", $Previous_S, $Previous);
		$Previous = str_replace("['Previous_L_V']", $Previous_L_V, $Previous);
	}

	if ($Next != $NextNoLink)
	{
		$Next = str_replace("['Next_S']", $Next_S, $Next);
		$Next = str_replace("['Next_L_V']", $Next_L_V, $Next);
	}

	$NavBar = FileInclude($NavBar);
	if($NavBar_LeftDiv !=''){$NavBar_LeftDiv = FileInclude($NavBar_LeftDiv);}
	if($NavBar_CenterDiv !=''){$NavBar_CenterDiv = FileInclude($NavBar_CenterDiv);}
	if($NavBar_RightDiv !=''){$NavBar_RightDiv = FileInclude($NavBar_RightDiv);}

	$NavBar = str_replace("['NavBar_LeftDiv']", $NavBar_LeftDiv, $NavBar);
	$NavBar = str_replace("['NavBar_CenterDiv']", $NavBar_CenterDiv, $NavBar);
	$NavBar = str_replace("['NavBar_RightDiv']", $NavBar_RightDiv, $NavBar);

	$NavBar = str_replace("['Previous']", $Previous, $NavBar);
	$NavBar = str_replace("['Next']", $Next, $NavBar);
	$NavBar = str_replace("['S_Plus_L_View']", $S_Plus_L_View, $NavBar);
	$NavBar = str_replace("['TotalRecords']", $TotalRecords, $NavBar);
	$NavBar = str_replace("['FormAction']", $FormAction, $NavBar);
	
	return $NavBar;
}
?>