<?php

function SetErrorCodes()
{
	if (!isset($_SESSION[$EC_Array]))
	{
		$EC_Array = array();

		$EC_Array['E_FamOrgID'] = "<b>Invalid Group ID</b>";
		$EC_Array['E_MemberTypeID'] = "<b>Invalid MemberTypeID</b>";
		$EC_Array['E_MemberType'] = "<b>Invalid MemberType:</b><br />Please select one from the list.";
		$EC_Array['E_Name'] = "<b>Invalid Group Name:</b> Group Name can not be null.<br />Group Name must be between 1-20 characters.";
		$EC_Array['E_JoinYear'] = "<b>Invalid Join Year</b><br />Join Year must be between 1900 and 2099.";
		$EC_Array['E_JoinMonth'] = "<b>Invalid Join Month</b><br />Join Month must be between 01 and 12.";
		$EC_Array['E_JoinDay'] = "<b>Invalid Join Day</b><br />Join Day must be between 01 and 31 and appropriate for the month selected.";
		$EC_Array['E_JoinDate'] = "<b>Invalid Join Date:</b><br />These are required fields.<br />Also, day must match up with the month. i.e. February can not have 30 days.";
		$EC_Array['E_ExpYear'] = "<b>Invalid Expiration Year:</b><br />Expiration Year must be between 1900 and 2099 or be 0000 for no expiration date.";
		$EC_Array['E_ExpMonth'] = "<b>Invalid Expiration Month:</b><br />Expiration Month must be between 01 and 12 or be 00 for no expiration date.";
		$EC_Array['E_ExpDay'] = "<b>Invalid Expiration Day:</b><br />Expiration Day must be between 01 and 31 and appropriate for the month selected or 00 for no expiration date. i.e. February can not have 30 days.";
		$EC_Array['E_ExpDate'] = "<b>Invalid Expiration Date:</b><br />Expiration Date must be in the following format: YYYY-MM-DD. i.e. 23 January 2004 = 2004-01-23. No expiration date = 0000-00-00";
		$EC_Array['E_Directory'] = "<b>Invalid Directory:</b> Please choose Yes or No for directory.";
		$EC_Array['E_Street1'] = "<b>Invalid Street, line 1:</b><br />Street line 1 must be 50 characters or less.";
		$EC_Array['E_Street2'] = "<b>Invalid Street, line 2:</b><br />Street line 2 must be 50 characters or less.";
		$EC_Array['E_Street3'] = "<b>Invalid Street, line 3:</b><br />Street line 3 must be 50 characters or less.";
		$EC_Array['E_City'] = "<b>Invalid City:</b> City must be 20 characters or less.";
		$EC_Array['E_StateTwoLetter'] = "<b>Invalid State:</b><br />Please select a state from the list.";
		$EC_Array['E_Zip5'] = "<b>Invalid Zip-5:</b> Zip-5 must be 5 numbers. i.e. 22201";
		$EC_Array['E_Zip4'] = "<b>Invalid Zip-4:</b> Zip-4 can only be 4 numbers. i.e. 1234";
		$EC_Array['E_Zip'] = "<b>Invalid Zip:</b> Zip-5 can not be blank if Zip-4 is not.";
		$EC_Array['E_Region'] = "<b>Invalid Region:</b><br />Region can only be used for non-US addresses and must be 30 characters or less.";
		$EC_Array['E_Country'] = "<b>Invalid Country:</b><br />Country must be 30 characters or less. Please use USA for America.";
		$EC_Array['E_StateRegionCountry'] = "<b>Invalid State, Region & Country Combination:</b><br />Region is only for non-USA addresses.<br />If Country is not USA there must NOT be a state.<br />If there is a Region or State, there can NOT be the other.";
		$EC_Array['E_FamOrgNotes'] = "<b>Invalid Notes field:</b><br />The notes field can be no more than 1000 characters.";

		// Member
		$EC_Array['E_Title'] = "<b>Invalid Title:</b> Title must be XX characters or less.";
		$EC_Array['E_Salutation'] = "<b>Invalid Salutation:</b><br />Salutation must be XX characters or less. Examples include Dr., President, CEO and Owner";
		$EC_Array['E_FName'] = "<b>Invalid First Name:</b><br />First Name must be XX characters or less and can only contain letters (A-Z) and the following special characters: ' (apostrophe) and - (dash).";
		$EC_Array['E_MName'] = "<b>Invalid Middle Name:</b><br />Middle Name must be XX characters or less and can only contain letters (A-Z) and the following special characters: ' (apostrophe) and - (dash).";
		$EC_Array['E_LName'] = "<b>Invalid Last Name:</b><br />Last Name must be XX characters or less and can only contain letters (A-Z) and the following special characters: ' (apostrophe) and - (dash).";
		$EC_Array['E_Suffix'] = "<b>Invalid Suffix:</b><br />Suffix must be XX characters or less and can only contain letters (A-Z) and the following special characters: ' (apostrophe), - (dash), . (period) and , (comma).";
		$EC_Array['E_DOBYear'] = "<b>Invalid DOB Year:</b> DOB Year must be between 1900 and this year.";
		$EC_Array['E_DOBMonth'] = "<b>Invalid DOB Month:</b> DOB Month must be between 01 and 12.";
		$EC_Array['E_DOBDay'] = "<b>Invalid DOB Day:</b><br />DOB Day must be between 01 and 31 and appropriate for the month selected. i.e. February can not have 30 days.";
		$EC_Array['E_DOBDate'] = "<b>Invalid DOB Date:</b><br />DOB Date must be in the following format: YYYY-MM-DD. i.e. 23 January 2004 = 2004-01-23.";
		$EC_Array['E_Gender'] = "<b>Invalid Gender:</b> Please choose M, Male or F, Female for Gender.";
		$EC_Array['E_MemberNotes'] = "<b>Invalid Notes field:</b> The notes field can be no more than 1000 characters.";

		// Dues
		$EC_Array['E_DuesID'] = "<b>Invalid Dues ID:</b> There has been an error or you are trying to do something you shouldn't.";
		$EC_Array['E_AmtDue'] = "<b>Invalid Amount Due:</b> Amount Due must be a decimal number.";
		$EC_Array['E_AmtPaid'] = "<b>Invalid Amount Paid:</b> Amount Due must be a decimal number.";
		$EC_Array['E_PaidYear'] = "<b>Invalid Paid Year:</b> Paid Year must be between 1900 and this year.";
		$EC_Array['E_PaidMonth'] = "<b>Invalid Paid Month:</b> Paid Month must be between 01 and 12.";
		$EC_Array['E_PaidDay'] = "<b>Invalid Paid Day:</b><br />Paid Day must be between 01 and 31 and appropriate for the month selected.<br />i.e. February can not have 30 days.";
		$EC_Array['E_PaidDate'] = "<b>Invalid Paid Date:</b><br />Paid Date must be in the following format: YYYY-MM-DD. i.e. 23 Janunary 2004 = 2004-01-23.";
		$EC_Array['E_DuesNotes'] = "<b>Invalid Notes field:</b> The notes field can be no more than 1000 characters.";


		$_SESSION['EC_Array'] = $EC_Array; // Set the table array
	}
	else
	{
		$EC_Array = $_SESSION['EC_Array'];
	}

	return $EC_Array;
}



?>