<?php
//
// This file currently includes 6 sub-functions. They are:
//
//        SUB FUNCTION              CALLING VAR
//    1  Set_MemberTypeArray()      MemberTypeArray
//    2  Set_ContactTypeArray()     ContactTypeArray
//    3  Set_VolunteerTypeArray()   VolunteerTypeArray
//    4  Set_StateListArray()       StateListArray
//    5  Set_FamOrgActiveArray()    FamOrgActiveArray
//    6  Set_MonthArray()  			MonthArray
//
// These functions are used in combination with the $SESSION() variables to reduce the need to perform MySQL queries.
// If the output arrays exist as $_SESSION() vars, the code will use that. If not, it will do the MySQL query
//
//
// The sub-functions can probably be combined into the master function to reduce code.... look into this in future.
//
// This is the master function which calls the subfunctions. If adding more sub-functions, don't forget to add in a line to the switch statement!
function Set_Check($TableArray, $ForceSet)
{
	if (!isset($_SESSION[$TableArray]) || $ForceSet)
	{
		switch ($TableArray)
		{
			case 'MemberTypeArray'    : {$TableArrayValue = Set_MemberTypeArray(); break;}
			case 'ContactTypeArray'   : {$TableArrayValue = Set_ContactTypeArray(); break;}
			case 'VolunteerTypeArray' : {$TableArrayValue = Set_VolunteerTypeArray(); break;}
			case 'StateListArray'     : {$TableArrayValue = Set_StateListArray(); break;}
			case 'FamOrgActiveArray'  : {$TableArrayValue = Set_FamOrgActiveArray(); break;}
			case 'MonthArray'		  : {$TableArrayValue = Set_MonthArray(); break;}
		}

		$_SESSION[$TableArray] = $TableArrayValue; // Set the table array
	}
	else
	{
		$TableArrayValue = $_SESSION[$TableArray];
	}

	return $TableArrayValue;
}


// Grabs all of the values from the MemberType table and puts them into an array using the field names as var names

function Set_MemberTypeArray()
{

	// the actual query
	$query = "SELECT *
				FROM MemberType
				ORDER BY MemberType.MemberType ASC";
	$result = mysql_query($query);

	// Another error check that needs to be replaced...
	if (!$result)
	{
		$MemberTypeArray = 'There was a problem setting the MemberTypeArray!';
		exit;
	}
	$i=0;
	while($row = mysql_fetch_array($result))
	{
		foreach($row as $key => $val)
		{$$key = stripslashes( $val );}

		$MemberTypeArray[$i] = array('MemberTypeID' => $MemberTypeID, 'MemberType' => $MemberType, 'DuesRate' => $DuesRate, 'DuesFrequency' => $DuesFrequency, 'MemberTypeNotes' => $MemberTypeNotes);
		$i++;
	}

	return $MemberTypeArray;
}


// Grabs all of the values from the ContactType table and puts them into an array using the field names as var names

function Set_ContactTypeArray()
{
	// the actual query
	$query = "SELECT *
				FROM ContactType
				ORDER BY ContactType.ContactType asc";
	$result = mysql_query($query);

	// Another error check that needs to be replaced...
	if (!$result)
	{
		$ContactTypeArray = 'There was a problem setting the ContactTypeArray!';
		exit;
	}

	$i=0;
	while($row = mysql_fetch_array($result))
	{
		foreach($row as $key => $val)
		{$$key = stripslashes( $val );}

		$ContactTypeArray[$i] = array('ContactTypeID' => $ContactTypeID, 'ContactType' => $ContactType);
		$i++;
	}

	return $ContactTypeArray;
}


// Grabs all of the values from the VolunteerType table and puts them into an array using the field names as var names

function Set_VolunteerTypeArray()
{
	// the actual query
	$query = "SELECT *
				FROM VolunteerType
				ORDER BY VolunteerType.VolType asc";
	$result = mysql_query($query);

	// Another error check that needs to be replaced...
	if (!$result)
	{
		$VolunteerTypeArray = 'There was a problem setting the VolunteerTypeArray!';
		exit;
	}

	$i=0;
	while($row = mysql_fetch_array($result))
	{
		foreach($row as $key => $val)
		{$$key = stripslashes( $val );}

		$VolunteerTypeArray[$i] = array('VolTypeID' => $VolTypeID, 'VolType' => $VolType, 'VolDescription' => $VolDescription);
		$i++;
	}

	return $VolunteerTypeArray;
}


// Grabs all of the values from the State table table and puts them into an array using the field names as var names

function Set_StateListArray()
{
	// the actual query
	$query = "SELECT *
				FROM StateList
				ORDER BY StateList.StateName ASC";
	$result = mysql_query($query);

	// Another error check that needs to be replaced...
	if (!$result)
	{
		$StateListArray = 'There was a problem setting the StateListArray!';
		exit;
	}

	$i=0;
	while($row = mysql_fetch_array($result))
	{
		foreach($row as $key => $val)
		{$$key = stripslashes( $val );}

		$StateListArray[$i] = array('StateID' => $StateID, 'StateName' => $StateName, 'StateTwoLetter' => $StateTwoLetter);
		$i++;
	}

	return $StateListArray;
}


// Grabs all active members from the FamOrg table (and grabs MemberType) and puts them into an array using the field names as var names

function Set_FamOrgActiveArray()
{
	// the actual query
	$query = "SELECT FamOrg.*, MemberType
				FROM FamOrg
				LEFT JOIN MemberType ON (FamOrg.MemberTypeID = MemberType.MemberTypeID)
				WHERE FamOrg.FamOrgArchive ='0'
				ORDER BY FamOrgID ASC";
	$result = mysql_query($query);

	// Another error check that needs to be replaced...
	if (!$result)
	{
		$FamOrgActiveArray = 'There was a problem setting the FamOrgArray!';
		exit;
	}

	$i=0;
	while($row = mysql_fetch_array($result))
	{
		foreach($row as $key => $val)
		{$$key = stripslashes( $val );}

		$FamOrgActiveArray[$i] = array('FamOrgID' => $FamOrgID, 'MemberTypeID' => $MemberTypeID, 'MemberType' => $MemberType,
										'Name' => $Name, 'JoinDate' => $JoinDate, 'ExpDate' => $ExpDate, 'Directory' => $Directory,
										'FamOrgArchive' => $FamOrgArchive, 'Street1' => $Street1, 'Street2' => $Street2,
										'Street3' => $Street3, 'City' => $City, 'StateTwoLetter' => $StateTwoLetter,
										'Zip' => $Zip, 'Region' => $Region, 'Country' => $Country, 'FamOrgNotes' => $FamOrgNotes);
		$i++;
	}

	return $FamOrgActiveArray;
}



// Does not do a query - just sets the Month array.

function Set_MonthArray()
{
	$MonthArray = array(
					array(Number => 1, Long => 'January', ShortCap => 'JAN', ShortLC => 'Jan'),
					array(Number => 2, Long => 'February', ShortCap => 'FEB', ShortLC => 'Feb'),
					array(Number => 3, Long => 'March', ShortCap => 'MAR', ShortLC => 'Mar'),
					array(Number => 4, Long => 'April', ShortCap => 'APR', ShortLC => 'Apr'),
					array(Number => 5, Long => 'May', ShortCap => 'MAY', ShortLC => 'May'),
					array(Number => 6, Long => 'June', ShortCap => 'JUN', ShortLC => 'Jun'),
					array(Number => 7, Long => 'July', ShortCap => 'JUL', ShortLC => 'Jul'),
					array(Number => 8, Long => 'August', ShortCap => 'AUG', ShortLC => 'Aug'),
					array(Number => 9, Long => 'September', ShortCap => 'SEP', ShortLC => 'Sep'),
					array(Number => 10, Long => 'October', ShortCap => 'OCT', ShortLC => 'Oct'),
					array(Number => 11, Long => 'November', ShortCap => 'NOV', ShortLC => 'Nov'),
					array(Number => 12, Long => 'December', ShortCap => 'DEC', ShortLC => 'Dec')
					);
	return $MonthArray;
}


?>