<?php

// This file contains the Renewal Reminders Email templates.
// They are a little different than other templates but close enough.

/*
	The general flow of the renewal reminder sstem is as follows:
	
	2 months before the membership expires, a renewal reminder email is sent.
	1 month before the membership expires, a letter is sent.
	2 months after the membership has expired, a renewal reminder email is sent.
	3 months after the membership has expired, membership is archived.

	Example:
	Johnny's membership expires on June 3rd.
	
	In April Johnny will receive an automatic email from the system reminding
	him that his membership expires in 2 months and he can save the club effort
	and money by filling out the attached renewal form and mailing it in.
	
	In May, if Johnny's membership has not been renewed (i.e. still expires this June),
	A renewal form is printed from the system (see reports) and sent to him.
	
	In August, if Johnny has still not renewed, another renewal reminder email is sent.
	This time the reminder says he will be dropped if he does not renew within 30 days.
	
	In September if Johnny has not renewed, his membership is dropped (archived).

*/


// This is the 2 month in the future email. ****************NEEDS WORK!!

$TwoMonthAheadTemplate = "Dear ['Salutation'],\r\n \r\n".
						"According to our records, your membership will expire on ['ExpDate'] and we don't want to lose you as a member!\r\n \r\n".
						"To renew your membership, please print out the attached PDF renewal form, make any corrections needed and return it along with your membership dues to \"DCRRC, PO Box 1352, Arlington VA 22210\".\r\n \r\n".
						"As a reminder, memberships must be renewed annually in order to remain active, and renewals are due each year on the same day the member joined.\r\n \r\n".
						"Please do not hesitate to email me at ['MembershipCoordinatorEmail'] with any questions or concerns you may have.\r\n".
						"\r\n".
						"Thank you,\r\n".
						"\r\n".
						"['MembershipCoordinatorFullName']\r\n".
						"DCRRC Membership Coordinator\r\n";


// This is the 2 month overdue email.

$TwoMonthPastTemplate = "Dear ['Salutation'],\r\n \r\n".
						"According to our records, your membership expired on ['ExpDate'] and we don't want to lose you as a member!\r\n \r\n".
						"To renew your membership, please print out the attached PDF renewal form, make any corrections needed and return it along with your membership dues to \"DCRRC, PO Box 1352, Arlington VA 22210\".\r\n \r\n".
						"As a reminder, memberships must be renewed annually in order to remain active. Renewals are due each year on the same day you joined. We don't want to lose you but if we do not hear from you within the next 30 days your membership will become inactive. If you believe this information is not correct please notify me by return email of the date you renewed.\r\n \r\n".
						"Please do not hesitate to email me at ['MembershipCoordinatorEmail'] with any questions or concerns.\r\n".
						"\r\n".
						"Thank you,\r\n".
						"\r\n".
						"['MembershipCoordinatorFullName']\r\n".
						"DCRRC Membership Coordinator\r\n";


?>